//
//  main.swift
//  week12
//
//  Created by Wen on 10.12.17.
//  Copyright © 2017 Doplab. All rights reserved.
//

import Foundation

class Human {
    let firstname: String
    let lastname: String
    var affiliate: String
    
    init(firstname: String, lastname: String, affiliate: String) {
        self.firstname = firstname
        self.lastname = lastname
        self.affiliate = affiliate
    }
    
    func doSomething(somebody: Human){
        if somebody is NormalPeople{
            print("I will save you \(somebody.firstname) \(somebody.lastname).")
        }else if somebody is BadPeople {
            print("I will hurt \(somebody.firstname) \(somebody.lastname).")
        }else {
            print("I don't know what to do !")
        }
    }
}

protocol Info {
    func getInfo()
}

class BadPeople: Human, Info {
    init(firstname: String, lastname: String) {
        super.init(firstname: firstname, lastname: lastname, affiliate: "Criminal")
    }
    
    func getInfo() {
        print("I will not tell you my name. I'm a \(affiliate).")
    }
    
    func hurt(somebody: Human){
        print("I will hurt \(somebody.firstname) \(somebody.lastname).")
    }
}

class GoodPeople: Human, Info {
    override init(firstname: String, lastname: String, affiliate: String) {
        super.init(firstname: firstname, lastname: lastname, affiliate: affiliate)
    }
    
    func getInfo() {
        print("Hi my name is \(self.firstname) \(self.lastname). I'm a \(self.affiliate)")
    }
}

class NormalPeople: GoodPeople {
    init(firstname: String, lastname: String) {
        super.init(firstname: firstname, lastname: lastname, affiliate: "Simple citizen")
    }
}

class Hero: GoodPeople{
    var alias: String
    
    init(firstname: String, lastname: String, alias: String) {
        self.alias = alias
        super.init(firstname: firstname, lastname: lastname, affiliate: "Justice League")
    }
    
    override func getInfo() {
        print("Hi my name is \(self.firstname) \(self.lastname), but you know me as \(self.alias). I'm in the \(self.affiliate). I will protect the world!")
    }
}



var theJocker=BadPeople(firstname:"The", lastname:"Jocker")
theJocker.getInfo()
var james=NormalPeople(firstname:"James", lastname: "Gordon")
james.getInfo()
var batman=Hero(firstname: "Bruce",lastname: "Wayne",alias: "Batman")
batman.getInfo()
theJocker.hurt(somebody: james)
batman.doSomething(somebody: james)
batman.doSomething(somebody: theJocker)


